Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 872)
+++ src/mlx/gui/flight.py	(revision 1008)
@@ -4218,22 +4220,14 @@
             self._derateLabel.set_sensitive(True)
 
-            if pygobject:
-                nominal = gtk.RadioButton.\
-                  new_with_label_from_widget(None,
-                                             xstr("takeoff_derate_tupolev_nominal"))
-            else:
-                nominal = gtk.RadioButton(None,
-                                          xstr("takeoff_derate_tupolev_nominal"))
+            nominal = Gtk.RadioButton.\
+                new_with_label_from_widget(None,
+                                           xstr("takeoff_derate_tupolev_nominal"))
             nominal.set_use_underline(True)
             nominal.set_tooltip_text(xstr("takeoff_derate_tupolev_nominal_tooltip"))
             nominal.connect("toggled", self._derateChanged)
 
-            if pygobject:
-                takeoff = gtk.RadioButton.\
-                  new_with_label_from_widget(nominal,
-                                             xstr("takeoff_derate_tupolev_takeoff"))
-            else:
-                takeoff = gtk.RadioButton(nominal,
-                                          xstr("takeoff_derate_tupolev_takeoff"))
+            takeoff = Gtk.RadioButton.\
+                new_with_label_from_widget(nominal,
+                                           xstr("takeoff_derate_tupolev_takeoff"))
 
             takeoff.set_use_underline(True)
@@ -4243,5 +4237,5 @@
             self._derateButtons = [nominal, takeoff]
 
-            self._derateWidget = gtk.HBox()
+            self._derateWidget = Gtk.HBox()
             self._derateWidget.pack_start(nominal, False, False, 4)
             self._derateWidget.pack_start(takeoff, False, False, 4)
@@ -4251,5 +4245,5 @@
             self._derateLabel.set_text("")
 
-            self._derateWidget = gtk.CheckButton(xstr("takeoff_derate_b462"))
+            self._derateWidget = Gtk.CheckButton(xstr("takeoff_derate_b462"))
             self._derateWidget.set_tooltip_text(xstr("takeoff_derate_b462_tooltip"))
             self._derateWidget.set_use_underline(True)
@@ -4262,5 +4256,5 @@
     def _metarChanged(self, entry):
         """Called when the METAR has changed."""
-        print "TakeoffPage.metarChanged", self._updatingMETAR
+        print("TakeoffPage.metarChanged", self._updatingMETAR)
         if not self._updatingMETAR:
             self._updateForwardButton()
@@ -4271,5 +4265,5 @@
 
         It uppercases all characters."""
-        print "TakeoffPage.metarInserted", self._updatingMETAR
+        print("TakeoffPage.metarInserted", self._updatingMETAR)
         if not self._updatingMETAR:
             self._updatingMETAR = True
@@ -4294,22 +4288,22 @@
         self._activated = False
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.0,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.0,
                                   xscale = 0.0, yscale = 1.0)
 
-        mainBox = gtk.VBox()
+        mainBox = Gtk.VBox()
         alignment.add(mainBox)
         self.setMainWidget(alignment)
 
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                   xscale = 0.0, yscale = 0.0)
         mainBox.pack_start(alignment, False, False, 16)
 
-        levelBox = gtk.HBox()
-
-        label = gtk.Label(xstr("route_level"))
+        levelBox = Gtk.HBox()
+
+        label = Gtk.Label(xstr("route_level"))
         label.set_use_underline(True)
         levelBox.pack_start(label, True, True, 0)
 
-        self._cruiseLevel = gtk.SpinButton()
+        self._cruiseLevel = Gtk.SpinButton()
         self._cruiseLevel.set_increments(step = 10, page = 100)
         self._cruiseLevel.set_range(min = 50, max = 500)
@@ -4321,5 +4315,5 @@
         levelBox.pack_start(self._cruiseLevel, False, False, 8)
 
-        self._updateButton = gtk.Button(xstr("cruise_route_level_update"));
+        self._updateButton = Gtk.Button(xstr("cruise_route_level_update"));
         self._updateButton.set_use_underline(True)
         self._updateButton.set_tooltip_text(xstr("cruise_route_level_update_tooltip"))
@@ -4330,5 +4324,5 @@
         mainBox.pack_start(levelBox, False, False, 0)
 
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                   xscale = 0.0, yscale = 1.0)
         mainBox.pack_start(alignment, True, True, 0)
@@ -4408,8 +4402,8 @@
         self._flightEnded = False
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 0.0, yscale = 0.0)
 
-        table = gtk.Table(7, 24)
+        table = Gtk.Table(7, 24)
         table.set_row_spacings(4)
         table.set_col_spacings(16)
@@ -4420,10 +4414,10 @@
         row = 0
 
-        label = gtk.Label(xstr("landing_metar"))
+        label = Gtk.Label(xstr("landing_metar"))
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
         table.attach(label, 1, 2, row, row+1)
 
-        self._metar = gtk.Entry()
+        self._metar = Gtk.Entry()
         self._metar.set_width_chars(40)
         self._metar.set_tooltip_text(xstr("landing_metar_tooltip"))
@@ -4437,13 +4431,10 @@
         row += 1
 
-        label = gtk.Label(xstr("landing_star"))
+        label = Gtk.Label(xstr("landing_star"))
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
         table.attach(label, 1, 2, row, row + 1)
 
-        if pygobject:
-            self._star = gtk.ComboBox.new_with_model_and_entry(comboModel)
-        else:
-            self._star = gtk.ComboBoxEntry(comboModel)
+        self._star = Gtk.ComboBox.new_with_model_and_entry(comboModel)
 
         self._star.set_entry_text_column(0)
@@ -4457,13 +4448,10 @@
         row += 1
 
-        label = gtk.Label(xstr("landing_transition"))
+        label = Gtk.Label(xstr("landing_transition"))
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
         table.attach(label, 1, 2, row, row + 1)
 
-        if pygobject:
-            self._transition = gtk.ComboBox.new_with_model_and_entry(comboModel)
-        else:
-            self._transition = gtk.ComboBoxEntry(comboModel)
+        self._transition = Gtk.ComboBox.new_with_model_and_entry(comboModel)
 
         self._transition.set_entry_text_column(0)
@@ -4477,10 +4465,10 @@
         row += 1
 
-        label = gtk.Label(xstr("landing_runway"))
+        label = Gtk.Label(xstr("landing_runway"))
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
         table.attach(label, 1, 2, row, row + 1)
 
-        self._runway = gtk.Entry()
+        self._runway = Gtk.Entry()
         self._runway.set_width_chars(10)
         self._runway.set_tooltip_text(xstr("landing_runway_tooltip"))
@@ -4491,10 +4479,10 @@
         row += 1
 
-        label = gtk.Label(xstr("landing_approach"))
+        label = Gtk.Label(xstr("landing_approach"))
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
         table.attach(label, 1, 2, row, row + 1)
 
-        self._approachType = gtk.Entry()
+        self._approachType = Gtk.Entry()
         self._approachType.set_width_chars(10)
         self._approachType.set_tooltip_text(xstr("landing_approach_tooltip"))
@@ -4505,5 +4493,5 @@
         row += 1
 
-        label = gtk.Label(xstr("landing_vref"))
+        label = Gtk.Label(xstr("landing_vref"))
         label.set_use_markup(True)
         label.set_use_underline(True)
@@ -4518,10 +4506,10 @@
         label.set_mnemonic_widget(self._vref)
 
-        self._vrefUnit = gtk.Label(xstr("label_knots"))
+        self._vrefUnit = Gtk.Label(xstr("label_knots"))
         table.attach(self._vrefUnit, 4, 5, row, row + 1)
 
         row += 1
 
-        self._antiIceOn = gtk.CheckButton(xstr("landing_antiice"))
+        self._antiIceOn = Gtk.CheckButton(xstr("landing_antiice"))
         self._antiIceOn.set_use_underline(True)
         self._antiIceOn.set_tooltip_text(xstr("landing_antiice_tooltip"))
@@ -4628,5 +4616,5 @@
         pages."""
         if self._active:
-            print "LandingPage.changeMETAR"
+            print("LandingPage.changeMETAR")
             self._updatingMETAR = True
             self._metar.get_buffer().set_text(metar, -1)
@@ -4689,5 +4677,5 @@
     def _metarChanged(self, entry):
         """Called when the METAR has changed."""
-        print "LandingPage.metarChanged", self._updatingMETAR
+        print("LandingPage.metarChanged", self._updatingMETAR)
         if not self._updatingMETAR:
             self._updateForwardButton()
@@ -4698,5 +4686,5 @@
 
         It uppercases all characters."""
-        print "LandingPage.metarInserted", self._updatingMETAR
+        print("LandingPage.metarInserted", self._updatingMETAR)
         if not self._updatingMETAR:
             self._updatingMETAR = True
@@ -4740,5 +4728,5 @@
         self._lastSavePath = os.path.join(self._wizard.gui.config.pirepDirectory,
                                           self._getDefaultPIREPName())
-        self._lastSavePath = text2unicode(self._lastSavePath)
+        self._lastSavePath = self._lastSavePath
         self._savePIREP(page, automatic = True)
 
@@ -4776,6 +4764,6 @@
         dialog.hide()
 
-        if result==RESPONSETYPE_OK:
-            self._lastSavePath = text2unicode(dialog.get_filename())
+        if result==Gtk.ResponseType.OK:
+            self._lastSavePath = dialog.get_filename()
             self._savePIREP(page)
 
@@ -4795,9 +4783,9 @@
 
         if error:
-            type = MESSAGETYPE_ERROR
+            type = Gtk.MessageType.ERROR
             message = xstr("finish_save_failed")
-            secondary = xstr("finish_save_failed_sec") % (text2unicode(error),)
+            secondary = xstr("finish_save_failed_sec") % (error,)
         else:
-            type = MESSAGETYPE_INFO
+            type = Gtk.MessageType.INFO
             message = xstr("finish_save_done")
             if automatic:
@@ -4807,7 +4795,7 @@
             page.setPIREPSaved()
 
-        dialog = gtk.MessageDialog(parent = gui.mainWindow,
+        dialog = Gtk.MessageDialog(parent = gui.mainWindow,
                                    type = type, message_format = message)
-        dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+        dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
         dialog.set_title(WINDOW_TITLE_BASE)
         if secondary is not None:
@@ -4823,20 +4811,20 @@
         if self._savePIREPDialog is None:
             gui = self._wizard.gui
-            dialog = gtk.FileChooserDialog(title = WINDOW_TITLE_BASE + " - " +
+            dialog = Gtk.FileChooserDialog(title = WINDOW_TITLE_BASE + " - " +
                                            xstr("finish_save_title"),
-                                           action = FILE_CHOOSER_ACTION_SAVE,
-                                           buttons = (gtk.STOCK_CANCEL,
-                                                      RESPONSETYPE_CANCEL,
-                                                      gtk.STOCK_OK, RESPONSETYPE_OK),
+                                           action = Gtk.FileChooserAction.SAVE,
+                                           buttons = (Gtk.STOCK_CANCEL,
+                                                      Gtk.ResponseType.CANCEL,
+                                                      Gtk.STOCK_OK, Gtk.ResponseType.OK),
                                            parent = gui.mainWindow)
             dialog.set_modal(True)
             dialog.set_do_overwrite_confirmation(True)
 
-            filter = gtk.FileFilter()
+            filter = Gtk.FileFilter()
             filter.set_name(xstr("file_filter_pireps"))
             filter.add_pattern("*.pirep")
             dialog.add_filter(filter)
 
-            filter = gtk.FileFilter()
+            filter = Gtk.FileFilter()
             filter.set_name(xstr("file_filter_all"))
             filter.add_pattern("*.*")
@@ -4857,8 +4845,8 @@
                                          xstr("finish_title"), help)
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 0.0, yscale = 0.0)
 
-        table = gtk.Table(10, 2)
+        table = Gtk.Table(10, 2)
         table.set_row_spacings(4)
         table.set_col_spacings(16)
@@ -4869,11 +4857,11 @@
         row = 0
 
-        labelAlignment = gtk.Alignment(xalign=1.0, xscale=0.0)
-        label = gtk.Label(xstr("finish_rating"))
+        labelAlignment = Gtk.Alignment(xalign=1.0, xscale=0.0)
+        label = Gtk.Label(xstr("finish_rating"))
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        labelAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
-        self._flightRating = gtk.Label()
+        labelAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
+        self._flightRating = Gtk.Label()
         self._flightRating.set_width_chars(8)
         self._flightRating.set_alignment(0.0, 0.5)
@@ -4884,11 +4872,11 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign=1.0, xscale=0.0)
-        label = gtk.Label(xstr("finish_dep_time"))
+        labelAlignment = Gtk.Alignment(xalign=1.0, xscale=0.0)
+        label = Gtk.Label(xstr("finish_dep_time"))
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        labelAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
-        self._depTime = gtk.Label()
+        labelAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
+        self._depTime = Gtk.Label()
         self._depTime.set_width_chars(13)
         self._depTime.set_alignment(0.0, 0.5)
@@ -4900,11 +4888,11 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign=1.0, xscale=0.0)
-        label = gtk.Label(xstr("finish_flight_time"))
+        labelAlignment = Gtk.Alignment(xalign=1.0, xscale=0.0)
+        label = Gtk.Label(xstr("finish_flight_time"))
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        labelAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
-        self._flightTime = gtk.Label()
+        labelAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
+        self._flightTime = Gtk.Label()
         self._flightTime.set_width_chars(10)
         self._flightTime.set_alignment(0.0, 0.5)
@@ -4915,11 +4903,11 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign=1.0, xscale=0.0)
-        label = gtk.Label(xstr("finish_block_time"))
+        labelAlignment = Gtk.Alignment(xalign=1.0, xscale=0.0)
+        label = Gtk.Label(xstr("finish_block_time"))
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        labelAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
-        self._blockTime = gtk.Label()
+        labelAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
+        self._blockTime = Gtk.Label()
         self._blockTime.set_width_chars(10)
         self._blockTime.set_alignment(0.0, 0.5)
@@ -4930,11 +4918,11 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign=1.0, xscale=0.0)
-        label = gtk.Label(xstr("finish_arr_time"))
+        labelAlignment = Gtk.Alignment(xalign=1.0, xscale=0.0)
+        label = Gtk.Label(xstr("finish_arr_time"))
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        labelAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
-        self._arrTime = gtk.Label()
+        labelAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
+        self._arrTime = Gtk.Label()
         self._arrTime.set_width_chars(13)
         self._arrTime.set_alignment(0.0, 0.5)
@@ -4946,11 +4934,11 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign=1.0, xscale=0.0)
-        label = gtk.Label(xstr("finish_distance"))
+        labelAlignment = Gtk.Alignment(xalign=1.0, xscale=0.0)
+        label = Gtk.Label(xstr("finish_distance"))
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        labelAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
-        self._distanceFlown = gtk.Label()
+        labelAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
+        self._distanceFlown = Gtk.Label()
         self._distanceFlown.set_width_chars(10)
         self._distanceFlown.set_alignment(0.0, 0.5)
@@ -4961,11 +4949,11 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign=1.0, xscale=0.0)
-        label = gtk.Label(xstr("finish_fuel"))
+        labelAlignment = Gtk.Alignment(xalign=1.0, xscale=0.0)
+        label = Gtk.Label(xstr("finish_fuel"))
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        labelAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
-        self._fuelUsed = gtk.Label()
+        labelAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
+        self._fuelUsed = Gtk.Label()
         self._fuelUsed.set_width_chars(10)
         self._fuelUsed.set_alignment(0.0, 0.5)
@@ -4976,7 +4964,7 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign = 1.0, xscale = 0.0,
+        labelAlignment = Gtk.Alignment(xalign = 1.0, xscale = 0.0,
                                        yalign = 0.5, yscale = 0.0)
-        label = gtk.Label(xstr("finish_type"))
+        label = Gtk.Label(xstr("finish_type"))
         label.set_use_underline(True)
         labelAlignment.add(label)
@@ -4987,5 +4975,5 @@
         self._flightType.set_active(0)
         self._flightType.connect("changed", self._flightTypeChanged)
-        flightTypeAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
+        flightTypeAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
         flightTypeAlignment.add(self._flightType)
         table.attach(flightTypeAlignment, 1, 2, row, row+1)
@@ -4994,8 +4982,8 @@
         row += 1
 
-        self._onlineFlight = gtk.CheckButton(xstr("finish_online"))
+        self._onlineFlight = Gtk.CheckButton(xstr("finish_online"))
         self._onlineFlight.set_use_underline(True)
         self._onlineFlight.set_tooltip_text(xstr("finish_online_tooltip"))
-        onlineFlightAlignment = gtk.Alignment(xalign=0.0, xscale=0.0)
+        onlineFlightAlignment = Gtk.Alignment(xalign=0.0, xscale=0.0)
         onlineFlightAlignment.add(self._onlineFlight)
         table.attach(onlineFlightAlignment, 1, 2, row, row + 1)
@@ -5003,20 +4991,20 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign = 1.0, xscale = 0.0,
+        labelAlignment = Gtk.Alignment(xalign = 1.0, xscale = 0.0,
                                        yalign = 0.5, yscale = 0.0)
-        self._gateLabel = gtk.Label(xstr("finish_gate"))
+        self._gateLabel = Gtk.Label(xstr("finish_gate"))
         self._gateLabel.set_use_underline(True)
         labelAlignment.add(self._gateLabel)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        self._gatesModel = gtk.ListStore(str)
-
-        self._gate = gtk.ComboBox(model = self._gatesModel)
-        renderer = gtk.CellRendererText()
+        self._gatesModel = Gtk.ListStore(str)
+
+        self._gate = Gtk.ComboBox(model = self._gatesModel)
+        renderer = Gtk.CellRendererText()
         self._gate.pack_start(renderer, True)
         self._gate.add_attribute(renderer, "text", 0)
         self._gate.set_tooltip_text(xstr("finish_gate_tooltip"))
         self._gate.connect("changed", self._gateChanged)
-        gateAlignment = gtk.Alignment(xalign=0.0, xscale=1.0)
+        gateAlignment = Gtk.Alignment(xalign=0.0, xscale=1.0)
         gateAlignment.add(self._gate)
         table.attach(gateAlignment, 1, 2, row, row+1)
@@ -5170,15 +5158,15 @@
         gui = self._wizard.gui
         if not self._pirepSent and not self._pirepSaved:
-            dialog = gtk.MessageDialog(parent = gui.mainWindow,
-                                       type = MESSAGETYPE_QUESTION,
+            dialog = Gtk.MessageDialog(parent = gui.mainWindow,
+                                       type = Gtk.MessageType.QUESTION,
                                        message_format = xstr("finish_newFlight_question"))
 
-            dialog.add_button(xstr("button_no"), RESPONSETYPE_NO)
-            dialog.add_button(xstr("button_yes"), RESPONSETYPE_YES)
+            dialog.add_button(xstr("button_no"), Gtk.ResponseType.NO)
+            dialog.add_button(xstr("button_yes"), Gtk.ResponseType.YES)
 
             dialog.set_title(WINDOW_TITLE_BASE)
             result = dialog.run()
             dialog.hide()
-            if result!=RESPONSETYPE_YES:
+            if result!=Gtk.ResponseType.YES:
                 return
 
@@ -5217,7 +5205,8 @@
         pass
 
-    def _formatTime(self, scheduledTime, realTimestamp, (warning, error)):
+    def _formatTime(self, scheduledTime, realTimestamp, warningError):
         """Format the departure or arrival time based on the given data as a
         markup for a label."""
+        (warning, error) = warningError
         realTime = time.gmtime(realTimestamp)
 
@@ -5287,7 +5276,7 @@
                                                     "")
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 1.0, yscale = 1.0)
-        self._label = gtk.Label()
+        self._label = Gtk.Label()
         alignment.add(self._label)
 
@@ -5364,5 +5353,5 @@
     def _checkFlightPassedSetCallback(self, returned, result):
         """Called when the check flight status has been set."""
-        gobject.idle_add(self._checkFlightPassedSet, returned, result)
+        GObject.idle_add(self._checkFlightPassedSet, returned, result)
 
     def _checkFlightPassedSet(self, returned, result):
@@ -5375,6 +5364,6 @@
             self._resetGUI()
         else:
-            dialog = gtk.MessageDialog(parent = gui.mainWindow,
-                                       type = MESSAGETYPE_ERROR,
+            dialog = Gtk.MessageDialog(parent = gui.mainWindow,
+                                       type = Gtk.MessageType.ERROR,
                                        message_format =
                                        xstr("chkfinish_passedset_failed"))
@@ -5395,5 +5384,5 @@
 #-----------------------------------------------------------------------------
 
-class Wizard(gtk.VBox):
+class Wizard(Gtk.VBox):
     """The flight wizard."""
     def __init__(self, gui):
@@ -5454,4 +5443,5 @@
 
         self._initialize()
+        self._allocateSize()
 
     def _sizeAllocate(self, widget, allocation):
@@ -5459,4 +5449,12 @@
            self._requestedHeight is not None:
            return
+
+        (maxWidth, maxHeight) = self._allocateSize()
+
+        self._requestedWidth = maxWidth
+        self._requestedHeight = maxHeight
+
+    def _allocateSize(self):
+        """Perform the real size allocation."""
 
         if self._currentPage is not None:
@@ -5469,6 +5467,6 @@
             self.show_all()
             pageSizeRequest = page.size_request()
-            width = pageSizeRequest.width if pygobject else pageSizeRequest[0]
-            height = pageSizeRequest.height if pygobject else pageSizeRequest[1]
+            width = pageSizeRequest.width
+            height = pageSizeRequest.height
             maxWidth = max(maxWidth, width)
             maxHeight = max(maxHeight, height)
@@ -5478,7 +5476,7 @@
             self.add(self._pages[self._currentPage])
 
-        self._requestedWidth = maxWidth
-        self._requestedHeight = maxHeight
         self.set_size_request(maxWidth, maxHeight)
+
+        return (maxWidth, maxHeight)
 
     @property
@@ -5752,5 +5750,5 @@
         elif stage==const.STAGE_LANDING:
             if not self._arrivalBriefingPage.metarEdited:
-                print "Downloading arrival METAR again"
+                print("Downloading arrival METAR again")
                 self.gui.webHandler.getMETARs(self._arrivalMETARCallback,
                                               [self._bookedFlight.arrivalICAO])
@@ -5881,5 +5879,5 @@
     def _loginResultCallback(self, returned, result):
         """The login result callback, called in the web handler's thread."""
-        gobject.idle_add(self._handleLoginResult, returned, result)
+        GObject.idle_add(self._handleLoginResult, returned, result)
 
     def _handleLoginResult(self, returned, result):
@@ -5898,8 +5896,8 @@
                                    if self.entranceExam else
                                    xstr("login_invalid"))
-                dialog = gtk.MessageDialog(parent = self.gui.mainWindow,
-                                           type = MESSAGETYPE_ERROR,
+                dialog = Gtk.MessageDialog(parent = self.gui.mainWindow,
+                                           type = Gtk.MessageType.ERROR,
                                            message_format = message)
-                dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+                dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
                 dialog.set_title(WINDOW_TITLE_BASE)
                 if isReload:
@@ -5915,8 +5913,8 @@
             message = xstr("reload_failconn") if isReload \
                       else xstr("login_failconn")
-            dialog = gtk.MessageDialog(parent = self.gui.mainWindow,
-                                       type = MESSAGETYPE_ERROR,
+            dialog = Gtk.MessageDialog(parent = self.gui.mainWindow,
+                                       type = Gtk.MessageType.ERROR,
                                        message_format = message)
-            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+            dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
             dialog.set_title(WINDOW_TITLE_BASE)
             secondary = xstr("reload_failconn_sec") if isReload \
@@ -5981,5 +5979,5 @@
     def _arrivalMETARCallback(self, returned, result):
         """Called when the METAR of the arrival airport is retrieved."""
-        gobject.idle_add(self._handleArrivalMETAR, returned, result)
+        GObject.idle_add(self._handleArrivalMETAR, returned, result)
 
     def _handleArrivalMETAR(self, returned, result):
